import .connectives
import .leibniz
import .nat
constant permutation.invert_permut : (nat.nat) -> ((nat.nat) -> nat.nat) -> (nat.nat) -> nat.nat.
constant permutation.invert_permut_body : (nat.nat) -> ((nat.nat) -> nat.nat) -> (nat.nat) -> nat.nat.
axiom permutation.axiom_invert_permut : forall (n:nat.nat) , (((connectives.equal) (((nat.nat) -> nat.nat) -> (nat.nat) -> nat.nat)) (((permutation.invert_permut) ) (n))) ((((nat.filter_nat_type) (((nat.nat) -> nat.nat) -> (nat.nat) -> nat.nat)) ((permutation.invert_permut_body) )) (n)).
theorem permutation.eq_invert_permut : forall (n:nat.nat) , (((leibniz.leibniz) (((nat.nat) -> nat.nat) -> (nat.nat) -> nat.nat)) (((permutation.invert_permut) ) (n))) ((((nat.filter_nat_type) (((nat.nat) -> nat.nat) -> (nat.nat) -> nat.nat)) ((permutation.invert_permut_body) )) (n)) := fun (n : nat.nat) , ((((@connectives.equal_leibniz) (((nat.nat) -> nat.nat) -> (nat.nat) -> nat.nat)) (((permutation.invert_permut) ) (n))) ((((nat.filter_nat_type) (((nat.nat) -> nat.nat) -> (nat.nat) -> nat.nat)) ((permutation.invert_permut_body) )) (n))) ((@permutation.axiom_invert_permut) (n)).
theorem permutation.sym_eq_invert_permut : forall (n:nat.nat) , (((leibniz.leibniz) (((nat.nat) -> nat.nat) -> (nat.nat) -> nat.nat)) ((((nat.filter_nat_type) (((nat.nat) -> nat.nat) -> (nat.nat) -> nat.nat)) ((permutation.invert_permut_body) )) (n))) (((permutation.invert_permut) ) (n)) := fun (n : nat.nat) , ((((@leibniz.sym_leibniz) (((nat.nat) -> nat.nat) -> (nat.nat) -> nat.nat)) (((permutation.invert_permut) ) (n))) ((((nat.filter_nat_type) (((nat.nat) -> nat.nat) -> (nat.nat) -> nat.nat)) ((permutation.invert_permut_body) )) (n))) ((@permutation.eq_invert_permut) (n)).
